package org.ts.ddcs.DataItemTemplate;

import org.ts.ddcs.Log.LogHelper;
import org.ts.ddcs.Tool.BytesHelp;
import org.ts.ddcs.Tool.StringUtil;

import java.math.BigDecimal;

/**
 * FF02
 * 设备温度
 */
@SuppressWarnings("all")
public class DataItemTemplateEXT_02 extends DataItemTemplate {
    @Override
    public byte[] Stream(byte[] data) {
        byte[] remain = data;
        try {
            if (this.macth) {
                return remain;
            }
            int count = 0;
            String flag = BytesHelp.byte2HexStr(remain, count, 2);
            count += 2;
            if (flag.equals(this.feture)) {
                byte[] len = BytesHelp.subBytes(remain, count, 1);
                count += 1;
                int dataTotalLen = len[0] >> 3;
                int decimalLen = len[0] & 7;
                byte[] buff = BytesHelp.subBytes(remain, count, dataTotalLen);
                boolean dataError = true;
                for (int i = 0; i < buff.length; i++) {
                    if (buff[i] != (byte) 0xFF) {
                        dataError = false;
                        break;
                    }
                }
                if (!dataError) {
                    dataTotalLen += 1;
                    buff = BytesHelp.subBytes(remain, count, dataTotalLen);
                    count += dataTotalLen;
                    String hexStr = BytesHelp.byte2HexStr(buff);
                    StringBuffer dataStr = new StringBuffer(hexStr);
                    if (decimalLen != 0) {
                        dataStr.insert(dataStr.length() - decimalLen, ".");
                    }
                    String value = StringUtil.getPrettyNumber(dataStr.toString());
                    this.bigDecimalValue = new BigDecimal(value);
                } else {
                    count += dataTotalLen;
                    String hexStr = BytesHelp.byte2HexStr(buff);
                }
                remain = BytesHelp.subBytes(remain, count, remain.length - count);
                this.macth = true;
            }
        } catch (Exception e) {
            LogHelper.error(e);
        }
        return remain;
    }
}
